## taskd 1.1.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
if(POLICY CMP0037)
  cmake_policy(SET CMP0037 OLD)
endif()

include (CheckFunctionExists)
include (CheckStructHasMember)

set (HAVE_CMAKE true)

project (taskd)
set (PROJECT_VERSION "1.1.0")

OPTION(USE_GNUTLS "Build gnutls support." ON)

message ("CMAKE_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}")

include (CheckCXXCompilerFlag)

# NOTE: If we are to actually use C++11 features, we should either require
#       a compiler that supports the -std=c++11 flag or check for the
#       features used.
#       Relying on -std=c++0x or even -std=gnu++0x is highly volatile.

CHECK_CXX_COMPILER_FLAG("-std=c++11" _HAS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" _HAS_CXX0X)
CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" _HAS_GNU0X)

if (_HAS_CXX11)
  set (_CXX11_FLAGS "-std=c++11")
elseif (_HAS_CXX0X)
  message (WARNING "Enabling -std=c++0x draft compile flag. Your compiler does not support the standard '-std=c++11' option.  Consider upgrading.")
  set (_CXX11_FLAGS "-std=c++0x")
elseif (_HAS_GNU0X)
  message (WARNING "Enabling -std=gnu++0x draft compile flag. Your compiler does not support the standard '-std=c++11' option. Consider upgrading.")
  set (_CXX11_FLAGS "-std=gnu++0x")
else (_HAS_CXX11)
 message (FATAL_ERROR "C++11 support missing. Try upgrading your C++ compiler. If you have a good reason for using an outdated compiler, please let us know at support@taskwarrior.org.")
endif (_HAS_CXX11)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set (LINUX true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set (DARWIN true)
  set (_CXX11_FLAGS "${_CXX11_FLAGS} -stdlib=libc++")
elseif (${CMAKE_SYSTEM_NAME} MATCHES "kFreeBSD")
  set (KFREEBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set (FREEBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
  set (OPENBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
  set (NETBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  set (SOLARIS true)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "GNU")
  set (GNUHURD true)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "CYGWIN")
  set (CYGWIN true)
  # NOTE: Not setting -std=gnu++0x leads to compile errors even with
  #       GCC 4.8.3, and debugging those leads to insanity. Adding this
  #       workaround instead of fixing Cygwin.
  set (_CXX11_FLAGS "-std=gnu++0x")
else (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set (UNKNOWN true)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

set (CMAKE_CXX_FLAGS "${_CXX11_FLAGS} ${CMAKE_CXX_FLAGS}")

set (CMAKE_CXX_FLAGS "-Wall -Wsign-compare -Wreturn-type ${CMAKE_CXX_FLAGS}")

if (NETBSD)
   # Since readline, etc likely to be in /usr/pkg/lib, not standard library
   # Otherwise will remove links during install
   set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif (NETBSD)

if (FREEBSD)
SET (TASKD_MAN1DIR man/man1  CACHE STRING "Installation directory for man pages, section 1")
SET (TASKD_MAN5DIR man/man5  CACHE STRING "Installation directory for man pages, section 5")
else (FREEBSD)
SET (TASKD_MAN1DIR share/man/man1  CACHE STRING "Installation directory for man pages, section 1")
SET (TASKD_MAN5DIR share/man/man5  CACHE STRING "Installation directory for man pages, section 5")
endif (FREEBSD)
SET (TASKD_DOCDIR  share/doc/taskd CACHE STRING "Installation directory for doc files")
SET (TASKD_EXTDIR  libexec/taskd   CACHE STRING "Installation directory for the extensions")
SET (TASKD_BINDIR  bin             CACHE STRING "Installation directory for the program")

message ("-- Looking for SHA1 references")
if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
  set (HAVE_COMMIT true)
  execute_process (COMMAND git log -1 --pretty=format:%h
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                   OUTPUT_VARIABLE COMMIT)
  configure_file ( ${CMAKE_SOURCE_DIR}/commit.h.in
                   ${CMAKE_SOURCE_DIR}/commit.h)
  message ("-- Found SHA1 reference: ${COMMIT}")
endif (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@taskwarrior.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")

message ("-- Looking for GnuTLS")
find_package (GnuTLS REQUIRED)
if (GNUTLS_FOUND)
  set (HAVE_LIBGNUTLS true)
  set (TASKD_INCLUDE_DIRS ${TASKD_INCLUDE_DIRS} ${GNUTLS_INCLUDE_DIR})
  set (TASKD_LIBRARIES    ${TASKD_LIBRARIES}    ${GNUTLS_LIBRARIES})
endif (GNUTLS_FOUND)

message ("-- Looking for libuuid")
if (DARWIN OR FREEBSD)
  # Apple and FreeBSD include the uuid functions in their libc, rather than libuuid
  check_function_exists (uuid_unparse_lower HAVE_UUID_UNPARSE_LOWER)
else (DARWIN OR FREEBSD)
  find_path    (UUID_INCLUDE_DIR   uuid/uuid.h)
  find_library (UUID_LIBRARY NAMES uuid)
  if (UUID_INCLUDE_DIR AND UUID_LIBRARY)
    set (TASKD_INCLUDE_DIRS ${TASKD_INCLUDE_DIRS} ${UUID_INCLUDE_DIR})
    set (TASKD_LIBRARIES    ${TASKD_LIBRARIES}    ${UUID_LIBRARY})
    # Look for uuid_unparse_lower
    set (CMAKE_REQUIRED_INCLUDES  ${CMAKE_REQUIRED_INCLUDES}  ${UUID_INCLUDE_DIR})
    set (CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${UUID_LIBRARY})
    check_function_exists (uuid_unparse_lower HAVE_UUID_UNPARSE_LOWER)
  else (UUID_INCLUDE_DIR AND UUID_LIBRARY)
    message (FATAL_ERROR "-- libuuid not found.")
  endif (UUID_INCLUDE_DIR AND UUID_LIBRARY)
endif (DARWIN OR FREEBSD)

if (HAVE_UUID_UNPARSE_LOWER)
  message ("-- Found libuuid")
else (HAVE_UUID_UNPARSE_LOWER)
  message ("-- Found libuuid, using internal uuid_unparse_lower")
endif (HAVE_UUID_UNPARSE_LOWER)

check_function_exists (timegm          HAVE_TIMEGM)
check_function_exists (get_current_dir_name HAVE_GET_CURRENT_DIR_NAME)

check_struct_has_member ("struct tm"   tm_gmtoff    time.h                   HAVE_TM_GMTOFF)
check_struct_has_member ("struct stat" st_birthtime "sys/types.h;sys/stat.h" HAVE_ST_BIRTHTIME)

# Set the package language.
if (LANGUAGE)
  set (PACKAGE_LANGUAGE ${LANGUAGE})
else (LANGUAGE)
  set (PACKAGE_LANGUAGE 1)
endif (LANGUAGE)

set (LANGUAGE_ENG_USA 1)

message ("-- Configuring cmake.h")
configure_file (
  ${CMAKE_SOURCE_DIR}/cmake.h.in
  ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
add_subdirectory (doc)
if (EXISTS test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS test)

set (doc_FILES NEWS ChangeLog INSTALL AUTHORS COPYING)
foreach (doc_FILE ${doc_FILES})
  install (FILES ${doc_FILE}  DESTINATION ${TASKD_DOCDIR})
endforeach (doc_FILE)

install (PROGRAMS src/taskdctl DESTINATION ${TASKD_BINDIR})

# ---

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set (CPACK_SOURCE_IGNORE_FILES  "CMakeCache" "CMakeFiles" "CPackConfig" "CPackSourceConfig"
                                "_CPack_Packages" "cmake_install" "install_manifest"
                                "Makefile$" "test" "package-config"
                                "src/taskd$" "/\\.gitignore" "/\\.git/" "swp$")
include (CPack)

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
message ("-- Configuring man pages")
set (man_FILES taskd.1 taskdctl.1 taskdrc.5)
foreach (man_FILE ${man_FILES})
  configure_file (
    man/${man_FILE}.in
    man/${man_FILE})
endforeach (man_FILE)

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/   DESTINATION ${TASKD_MAN1DIR}
                                                      FILES_MATCHING PATTERN "*.1")
install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/   DESTINATION ${TASKD_MAN5DIR}
                                                      FILES_MATCHING PATTERN "*.5")

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${TASKD_INCLUDE_DIRS})

add_executable (taskd_executable taskd.cpp
                                 admin.cpp
                                 api.cpp
                                 client.cpp
                                 Color.cpp      Color.h
                                 ConfigFile.cpp ConfigFile.h
                                 config.cpp
                                 daemon.cpp
                                 diag.cpp
                                 Database.cpp   Database.h
                                 Date.cpp       Date.h
                                 Directory.cpp  Directory.h
                                 Duration.cpp   Duration.h
                                 l10n/eng-USA.h
                                 File.cpp       File.h
                                 help.cpp
                                 i18n.h
                                 init.cpp
                                 JSON.cpp       JSON.h
                                 Log.cpp        Log.h
                                 Msg.cpp        Msg.h
                                 Nibbler.cpp    Nibbler.h
                                 Path.cpp       Path.h
                                 RX.cpp         RX.h
                                 Server.cpp     Server.h
                                 status.cpp
                                 Task.cpp       Task.h
                                 text.cpp       text.h
                                 Timer.cpp      Timer.h
                                 TLSClient.cpp  TLSClient.h
                                 TLSServer.cpp  TLSServer.h
                                 utf8.cpp       utf8.h
                                 util.cpp       util.h
                                 wcwidth6.cpp)

target_link_libraries (taskd_executable ${TASKD_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

set_property (TARGET taskd_executable PROPERTY OUTPUT_NAME "taskd")

install (TARGETS taskd_executable DESTINATION ${TASKD_BINDIR})

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/test
                     ${TASKD_INCLUDE_DIRS})

set (test_SRCS color.t config.t date.t directory.t duration.t file.t msg.t
               nibbler.t path.t rx.t text.t util.t utf8.t json.t json_test)

message ("-- Configuring run_all")
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

set (TESTBLOB "./*.t")
if (CYGWIN)
  set (TESTBLOB "./*.t ./*.t.exe")
endif (CYGWIN)

else (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

set (TESTBLOB "${CMAKE_SOURCE_DIR}/test/*.t ${CMAKE_BINARY_DIR}/test/*.t")
if (CYGWIN)
  set (TESTBLOB "${CMAKE_SOURCE_DIR}/test/*.t ${CMAKE_BINARY_DIR}/test/*.t.exe")
endif (CYGWIN)

endif (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

configure_file (run_all.in run_all)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS}
                        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

add_custom_target (build_tests DEPENDS ${test_SRCS}
                               WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp"
                              ../src/Color.cpp
                              ../src/ConfigFile.cpp
                              ../src/Date.cpp
                              ../src/Directory.cpp
                              ../src/Duration.cpp
                              ../src/File.cpp
                              ../src/JSON.cpp
                              ../src/Msg.cpp
                              ../src/Nibbler.cpp
                              ../src/Path.cpp
                              ../src/RX.cpp
                              ../src/text.cpp
                              ../src/utf8.cpp
                              ../src/util.cpp
                              ../src/wcwidth6.cpp
                              test.cpp)
  target_link_libraries (${src_FILE} ${TASKD_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
endforeach (src_FILE)

=== debian/changelog ===
taskd (1.1.0+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Sebastien Badia ]
  * d/control:
    + Bump Standards-Version to 3.9.8 (no changes).
    + Switch to HTTPS for Vcs-Git URL.
    + Switch to pkg-tasktools team.

  [ Mattia Rizzolo ]
  * d/control: add dependency on lsb-base (>= 3.0-6) as the init script needs
    it (thanks, lintian).
  * Bump debhelper compat level to 10.
    + dh-systemd now runs automatically, drop dependency and explicit call.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 29 Oct 2016 23:09:34 +0000

taskd (1.1.0+dfsg-2) unstable; urgency=high

  * Fix old installation pattern,
    orgs are now created by user (Closes: #810342).

 -- Sebastien Badia <seb@sebian.fr>  Fri, 08 Jan 2016 17:45:59 +0100

taskd (1.1.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #721647).

 -- Sebastien Badia <seb@sebian.fr>  Sun, 27 Dec 2015 11:00:41 +0100

=== debian/control ===
Source: taskd
Section: utils
Priority: extra
Maintainer: Debian Tasktools Packaging Team <pkg-tasktools-discuss@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>, Sebastien Badia <seb@sebian.fr>
Build-Depends: cmake,
               debhelper (>= 10),
               libgnutls28-dev,
               perl,
               python,
               uuid-dev
Standards-Version: 3.9.8
Homepage: http://tasktools.org/projects/taskd.html
Vcs-Git: https://anonscm.debian.org/git/pkg-tasktools/taskd.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-tasktools/taskd.git

Package: taskd
Architecture: any
Depends: adduser,
         gnutls-bin,
         lsb-base (>= 3.0-6),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: taskwarrior
Description: Synchronisation server for taskwarrior
 This is the server for the taskwarrior synchronisation function
 (task sync). Multiple users and multiple clients per user are supported.
 Connections are secured with TLS using user-generated certificates.

=== debian/rules ===
#!/usr/bin/make -f

export CMAKE_BUILD_TYPE=release
PACKAGE = $(shell dh_listpackages)
TMP     = $(CURDIR)/debian/$(PACKAGE)

%:
	dh $@

clean:
	dh_clean
	rm -f cmake.h commit.h
	rm -rf obj-*

override_dh_installdocs:
	dh_installdocs
	rm -f $(TMP)/usr/share/doc/taskd/INSTALL \
	      $(TMP)/usr/share/doc/taskd/COPYING \
	      $(TMP)/usr/share/doc/taskd/AUTHORS \
	      $(TMP)/usr/share/doc/taskd/ChangeLog

override_dh_install:
	dh_install
	mv $(TMP)/usr/share/taskd/pki/README \
	   $(TMP)/usr/share/doc/taskd/README.pki
	mv $(TMP)/usr/share/taskd/mon/README \
	   $(TMP)/usr/share/doc/taskd/README.mon

=== debian/watch ===
version=3
opts="uversionmangle=s/[.]beta/~beta/,dversionmangle=s/[+]dfsg//" \
http://tasktools.org http://taskwarrior.org/download/taskd-(.*)\.tar\.gz
